#----------------------------------------------------#
# This script runs every game tick.
# All the map specific commands are called from here.
#
# Scripter: Liontack
# Called by tag: #main:tick
#----------------------------------------------------#




### Initialize players
execute as @e[type=player, tag=!initialized] run scoreboard players set @s deaths 0
execute as @e[type=player, tag=!initialized] run attribute @s generic.max_health base set 2
execute as @e[type=player, tag=!initialized] run effect give @s minecraft:health_boost 1 1 true
execute as @e[type=player, tag=!initialized] run tag @s add initialized



### Run timers
execute if score i_piston_timer variables matches 1.. run scoreboard players remove i_piston_timer variables 1

execute if score i_lava_timer variables matches 1.. run scoreboard players remove i_lava_timer variables 1
execute if score i_lava_timer variables matches 0 run scoreboard players set i_lava_timer variables 20

execute if score i_lava_sound_timer variables matches 1.. run scoreboard players remove i_lava_sound_timer variables 1
execute if score i_lava_sound_timer variables matches 0 run scoreboard players set i_lava_sound_timer variables 200

execute if score i_sword_timer variables matches 1.. run scoreboard players remove i_sword_timer variables 1
execute if score i_sword_timer variables matches 0 run scoreboard players set i_sword_timer variables 10



### Update the Liontack armorstand pose
execute if score b_apple_given variables matches 0 if score i_sword_timer variables matches 1 run data modify entity @e[tag=Liontack, nbt=!{HandItems:[{Count:1b}]}, limit=1] ArmorItems[3].tag.CustomModelData set value 1
execute if score b_apple_given variables matches 0 if score i_sword_timer variables matches 6 run data modify entity @e[tag=Liontack, nbt=!{HandItems:[{Count:1b}]}, limit=1] ArmorItems[3].tag.CustomModelData set value 2
execute if score b_apple_given variables matches 1 if score b_apple_taken variables matches 0 run data modify entity @e[tag=Liontack, limit=1] ArmorItems[3].tag.CustomModelData set value 3
execute if score b_apple_taken variables matches 1 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run data modify entity @e[tag=Liontack, limit=1] ArmorItems[3].tag.CustomModelData set value 3
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 8 unless entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run data modify entity @e[tag=Liontack, limit=1] ArmorItems[3].tag.CustomModelData set value 4
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 unless entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run data modify entity @e[tag=Liontack, limit=1] ArmorItems[3].tag.CustomModelData set value 5

execute if score b_apple_given variables matches 1 if score b_apple_taken variables matches 0 run data modify entity @e[tag=Liontack, limit=1] Pose.RightArm[0] set value 320f
execute if score b_apple_taken variables matches 1 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run data modify entity @e[tag=Liontack, limit=1] Pose.RightArm[0] set value 320f
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 8 unless entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run data modify entity @e[tag=Liontack, limit=1] Pose.RightArm[0] set value 200f
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 unless entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run data modify entity @e[tag=Liontack, limit=1] Pose.RightArm[0] set value 240f

execute if score b_apple_taken variables matches 1 unless entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run data modify entity @e[tag=Liontack, limit=1] HandItems[0] set value {id:"minecraft:diamond_sword", Count:1b}

execute if entity @e[tag=Liontack, nbt={HandItems:[{Count:1b}]}, nbt=!{HandItems:[{id:"minecraft:diamond_sword"}]}] run data modify entity @e[tag=Liontack, limit=1] Pose.RightArm[0] set value 320f
execute if entity @e[tag=Liontack, nbt={HandItems:[{Count:1b}]}, nbt=!{HandItems:[{id:"minecraft:diamond_sword"}]}] run data modify entity @e[tag=Liontack, limit=1] ArmorItems[3].tag.CustomModelData set value 3

clear @a diamond_sword



### Keep track of all player's rotation, position and health
execute as @e[type=player] store result score @s player_pitch run data get entity @s Rotation[0]
execute as @e[type=player] store result score @s player_yaw run data get entity @s Rotation[1]

execute as @e[type=player] store result score @s player_x_pos run data get entity @s Pos[0] 10
execute as @e[type=player] store result score @s player_y_pos run data get entity @s Pos[1] 10
execute as @e[type=player] store result score @s player_z_pos run data get entity @s Pos[2] 10

execute as @e[type=player] store result score @s hearts run data get entity @s Attributes[{Name:"minecraft:generic.max_health"}].Base
execute as @e[type=player] store result score @s golden_hearts run data get entity @s AbsorptionAmount
execute as @e[type=player] run scoreboard players operation @s hearts += @s golden_hearts

### Keep track of all projectiles positions
execute as @e[tag=projectile] store result score @s player_x_pos run data get entity @s Pos[0] 1
execute as @e[tag=projectile] store result score @s player_y_pos run data get entity @s Pos[1] 1
execute as @e[tag=projectile] store result score @s player_z_pos run data get entity @s Pos[2] 1

execute as @e[type=snowball] store result score @s player_x_pos run data get entity @s Pos[0] 10
execute as @e[type=snowball] store result score @s player_y_pos run data get entity @s Pos[1] 10
execute as @e[type=snowball] store result score @s player_z_pos run data get entity @s Pos[2] 10



### Restart if player walks on the respawn place
execute as @e[type=player, scores={player_z_pos=2080..}] run scoreboard players set b_walked_away_from_start variables 1
execute as @e[type=player] at @s if block ~ ~-0.1 ~ gold_block if score b_walked_away_from_start variables matches 1 run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" wanted to try again from the beginning."}]
execute as @e[type=player] at @s if block ~ ~-0.1 ~ gold_block if score b_walked_away_from_start variables matches 1 run function main:reset



### Restart if player jumped into the void
execute as @e[type=player, scores={player_y_pos=..820}] run tellraw @a [{"selector":"@s", "color":"yellow"}, {"color":"red", "text":" jumped into the void."}]
execute as @e[type=player, scores={player_y_pos=..820}] run function main:reset



### Spawn an anvil above any player who looks up
execute if score b_anvil_dropped variables matches 0 at @e[type=player, scores={player_yaw=..-85}] run fill ~ ~15 ~ ~ ~15 ~ anvil replace air
execute if score b_anvil_dropped variables matches 0 as @e[type=player, scores={player_yaw=..-85}] run scoreboard players set b_anvil_dropped variables 1
execute as @e[type=player] at @s positioned ~ ~1.5 ~ if entity @e[type=falling_block, distance=..0.9] positioned ~ ~1 ~ if entity @e[type=falling_block, distance=..0.9] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" got smashed by an anvil."}]
execute as @e[type=player] at @s positioned ~ ~1.5 ~ if entity @e[type=falling_block, distance=..0.9] positioned ~ ~1 ~ if entity @e[type=falling_block, distance=..0.9] run function main:reset

clear Liontack anvil
clear Liontack minecraft:chipped_anvil


### Constant particles
particle minecraft:enchant 209.5 102.5 192.5 0.5 0.5 0.5 1 1 force
particle minecraft:enchant 203.5 117.5 244.5 0.5 0.5 0.5 1 1 force
particle composter 203.5 117.00 246.5 .5 .5 0 0 2 force



### Area 1 logic
execute if score chest_kill_timer variables matches 0 as @e[type=player, scores={chests_opened=1..}] run scoreboard players set chest_kill_timer variables 10
execute if score chest_kill_timer variables matches 1.. run scoreboard players remove chest_kill_timer variables 1
execute if score chest_kill_timer variables matches 1 if entity @e[type=player, scores={chests_opened=1.., player_y_pos=940..}] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" tried to open the famous kill chest."}]
execute if score chest_kill_timer variables matches 1 as @e[type=player, scores={chests_opened=1.., player_y_pos=940..}] run function main:reset

execute if score b_apple_given variables matches 0 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run playsound minecraft:voice.liontack.thank_you master @a 212 102 206
execute if score b_apple_given variables matches 0 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run setblock 211 101 207 warped_fence_gate
execute if score b_apple_given variables matches 0 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run setblock 207 101 207 crimson_fence_gate
execute if score b_apple_given variables matches 0 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run particle minecraft:dust 0 255 0 1 211.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score b_apple_given variables matches 0 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run particle minecraft:dust 255 0 0 1 207.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score b_apple_given variables matches 0 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run scoreboard players set b_apple_taken variables 0
execute if score b_apple_given variables matches 0 if entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run scoreboard players set b_apple_given variables 1

execute if score b_apple_taken variables matches 0 if score b_apple_given variables matches 1 if score i_sword_timer variables matches 1 unless entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run playsound minecraft:voice.liontack.give_that_back master @a 212 102 206
execute if score b_apple_taken variables matches 0 if score b_apple_given variables matches 1 if score i_sword_timer variables matches 1 unless entity @e[tag=Liontack, nbt={HandItems:[{id:"minecraft:apple"}]}] run scoreboard players set b_apple_taken variables 1
execute if score b_apple_taken variables matches 1 run scoreboard players set b_apple_given variables 0
execute if score b_apple_taken variables matches 1 run scoreboard players set i_fence_gates_stage variables 0
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 run particle minecraft:sweep_attack 211 102.5 205 0 0 0 1 1
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 run playsound minecraft:entity.player.attack.sweep master @a 211 102 205 .1
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7] at @s run playsound minecraft:entity.player.hurt master @a 211 102 205
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=..6}] at @s run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" was slain by Liontack while taking back the apple."}]
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=..6}] at @s run function main:reset
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=8}] at @s run attribute @s generic.max_health base set 2
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=10}] at @s run attribute @s generic.max_health base set 4
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=12}] at @s run attribute @s generic.max_health base set 6
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=14}] at @s run attribute @s generic.max_health base set 8
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=16}] at @s run attribute @s generic.max_health base set 10
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=18}] at @s run attribute @s generic.max_health base set 12
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=20}] at @s run attribute @s generic.max_health base set 14
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=22}] at @s run attribute @s generic.max_health base set 16
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=24}] at @s run attribute @s generic.max_health base set 18
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=26}] at @s run attribute @s generic.max_health base set 20
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=28}] at @s run attribute @s generic.max_health base set 22
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=30}] at @s run attribute @s generic.max_health base set 24
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=32}] at @s run attribute @s generic.max_health base set 26
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=34}] at @s run attribute @s generic.max_health base set 28
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=36}] at @s run attribute @s generic.max_health base set 30
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=38}] at @s run attribute @s generic.max_health base set 32
execute if score b_apple_taken variables matches 1 if score i_sword_timer variables matches 1 at @e[tag=Liontack] positioned ^ ^ ^1.4 as @e[type=player, distance=..1.7, scores={hearts=40}] at @s run attribute @s generic.max_health base set 34


execute if score i_fence_gates_stage variables matches 0 if block 211 101 207 warped_fence_gate[open=true] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" opened the wrong fence gate."}]
execute if score i_fence_gates_stage variables matches 0 if block 211 101 207 warped_fence_gate[open=true] as @e[type=player, sort=nearest, limit=1] run function main:reset
execute if score i_fence_gates_stage variables matches 0 if block 207 101 207 crimson_fence_gate[open=true] run scoreboard players set i_fence_gates_stage variables 1
execute if score i_fence_gates_stage variables matches 1 run setblock 211 101 207 crimson_fence_gate
execute if score i_fence_gates_stage variables matches 1 run setblock 207 101 207 warped_fence_gate
execute if score i_fence_gates_stage variables matches 1 run particle minecraft:dust 255 0 0 1 211.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score i_fence_gates_stage variables matches 1 run particle minecraft:dust 0 255 0 1 207.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score i_fence_gates_stage variables matches 1 run scoreboard players set i_fence_gates_stage variables 2

execute if score i_fence_gates_stage variables matches 2 if block 207 101 207 warped_fence_gate[open=true] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" opened the wrong fence gate."}]
execute if score i_fence_gates_stage variables matches 2 if block 207 101 207 warped_fence_gate[open=true] as @e[type=player, sort=nearest, limit=1] run function main:reset
execute if score i_fence_gates_stage variables matches 2 if block 211 101 207 crimson_fence_gate[open=true] run scoreboard players set i_fence_gates_stage variables 3
execute if score i_fence_gates_stage variables matches 3 run setblock 211 101 207 warped_fence_gate
execute if score i_fence_gates_stage variables matches 3 run setblock 207 101 207 crimson_fence_gate
execute if score i_fence_gates_stage variables matches 3 run particle minecraft:dust 0 255 0 1 211.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score i_fence_gates_stage variables matches 3 run particle minecraft:dust 255 0 0 1 207.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score i_fence_gates_stage variables matches 3 run scoreboard players set i_fence_gates_stage variables 4

execute if score i_fence_gates_stage variables matches 4 if block 207 101 207 crimson_fence_gate[open=true] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" opened the wrong fence gate."}]
execute if score i_fence_gates_stage variables matches 4 if block 207 101 207 crimson_fence_gate[open=true] as @e[type=player, sort=nearest, limit=1] run function main:reset
execute if score i_fence_gates_stage variables matches 4 if block 211 101 207 warped_fence_gate[open=true] run scoreboard players set i_fence_gates_stage variables 5
execute if score i_fence_gates_stage variables matches 5 run setblock 211 101 207 crimson_fence_gate
execute if score i_fence_gates_stage variables matches 5 run setblock 207 101 207 warped_fence_gate
execute if score i_fence_gates_stage variables matches 5 run particle minecraft:dust 255 0 0 1 211.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score i_fence_gates_stage variables matches 5 run particle minecraft:dust 0 255 0 1 207.5 101.4 207.5 0.2 0.2 0.1 1 10 force
execute if score i_fence_gates_stage variables matches 5 run scoreboard players set i_fence_gates_stage variables 6

execute if score i_fence_gates_stage variables matches 6 if block 207 101 207 warped_fence_gate[open=true] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" opened the wrong fence gate."}]
execute if score i_fence_gates_stage variables matches 6 if block 207 101 207 warped_fence_gate[open=true] as @e[type=player, sort=nearest, limit=1] run function main:reset



### Area 2 logic
execute if block 209 105 210 warped_button[powered=true] run effect give @a minecraft:levitation 1 30 true
execute if block 209 105 210 warped_button[powered=true] run playsound minecraft:entity.shulker_bullet.hurt master @a 209 105 210
execute if block 209 105 210 warped_button[powered=true] at @a run particle minecraft:campfire_cosy_smoke ~ ~0.9 ~ 0.2 0.9 0.2 0 20 force
execute if block 209 105 210 warped_button[powered=true] as @e[type=player] run scoreboard players operation @s player_y_pos_set = @s player_y_pos
execute if block 209 105 210 warped_button[powered=true] run scoreboard players add @e[type=player] player_y_pos_set 30
execute if block 209 105 210 warped_button[powered=true] run setblock 209 105 210 air
execute if block 209 107 209 warped_button[powered=true] run effect give @a minecraft:levitation 1 30 true
execute if block 209 107 209 warped_button[powered=true] run playsound minecraft:entity.shulker_bullet.hurt master @a 209 107 209
execute if block 209 107 209 warped_button[powered=true] at @a run particle minecraft:campfire_cosy_smoke ~ ~0.9 ~ 0.2 0.9 0.2 0 20 force
execute if block 209 107 209 warped_button[powered=true] as @e[type=player] run scoreboard players operation @s player_y_pos_set = @s player_y_pos
execute if block 209 107 209 warped_button[powered=true] run scoreboard players add @e[type=player] player_y_pos_set 30
execute if block 209 107 209 warped_button[powered=true] run setblock 209 107 209 air

execute if block 209 105 210 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=105.5, z=210, distance=..0.5] run effect give @a minecraft:levitation 1 30 true
execute if block 209 105 210 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=105.5, z=210, distance=..0.5] run playsound minecraft:entity.shulker_bullet.hurt master @a 209 105 210
execute if block 209 105 210 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=105.5, z=210, distance=..0.5] at @a run particle minecraft:campfire_cosy_smoke ~ ~0.9 ~ 0.2 0.9 0.2 0 20 force
execute if block 209 105 210 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=105.5, z=210, distance=..0.5] as @e[type=player] run scoreboard players operation @s player_y_pos_set = @s player_y_pos
execute if block 209 105 210 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=105.5, z=210, distance=..0.5] run scoreboard players add @e[type=player] player_y_pos_set 30
execute if block 209 105 210 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=105.5, z=210, distance=..0.5] run setblock 209 105 210 air
execute if block 209 107 209 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=107.5, z=209, distance=..0.5] run effect give @a minecraft:levitation 1 30 true
execute if block 209 107 209 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=107.5, z=209, distance=..0.5] run playsound minecraft:entity.shulker_bullet.hurt master @a 209 107 209
execute if block 209 107 209 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=107.5, z=209, distance=..0.5] at @a run particle minecraft:campfire_cosy_smoke ~ ~0.9 ~ 0.2 0.9 0.2 0 20 force
execute if block 209 107 209 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=107.5, z=209, distance=..0.5] as @e[type=player] run scoreboard players operation @s player_y_pos_set = @s player_y_pos
execute if block 209 107 209 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=107.5, z=209, distance=..0.5] run scoreboard players add @e[type=player] player_y_pos_set 30
execute if block 209 107 209 warped_button[powered=false] if entity @e[type=trident, x=209.5, y=107.5, z=209, distance=..0.5] run setblock 209 107 209 air

execute as @e[type=player] if score @s player_y_pos > @s player_y_pos_set run tag @s add DeathFall
execute as @e[tag=DeathFall] at @s if block ~ ~-1 ~ sticky_piston run tag @s remove DeathFall
execute as @e[tag=DeathFall] at @s unless block ~ ~-1 ~ air unless block ~ ~-1 ~ polished_blackstone_button unless block ~ ~-1 ~ oak_pressure_plate run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" fell from a high place."}]
execute as @e[tag=DeathFall] at @s unless block ~ ~-1 ~ air unless block ~ ~-1 ~ polished_blackstone_button unless block ~ ~-1 ~ oak_pressure_plate run function main:reset
execute as @e[type=player] if data entity @s {OnGround:1b} unless data entity @s {ActiveEffects:[{Id:25b}]} run scoreboard players set @s player_y_pos_set 99999

#execute if entity @e[type=snowball, x=209, y=101, z=218, dx=1.0, dy=0.3, dz=1.0] run setblock 209 100 218 sticky_piston[facing=up]
execute if entity @e[type=snowball, scores={player_z_pos=2177..2193, player_y_pos=1000..1030, player_x_pos=2087..2103}] run setblock 209 100 218 sticky_piston[facing=up]

execute if block 209 101 218 jungle_button[powered=true] run setblock 209 99 218 redstone_block
execute if block 209 101 218 jungle_button[powered=true] run scoreboard players set i_piston_timer variables 10
execute if block 209 101 218 jungle_button[powered=true] run setblock 209 101 218 air
execute if score i_piston_timer variables matches 1 run setblock 209 99 218 air

execute if block 209 101 220 acacia_fence_gate[open=true] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" tried to open the middle acacia fence gate."}]
execute if block 209 101 220 acacia_fence_gate[open=true] as @e[type=player, sort=nearest, limit=1] run function main:reset

execute positioned 209.5 98.00 207.5 as @e[type=player, distance=..1] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" Trampled the roots of the knowledge tree."}]
execute positioned 209.5 98.00 207.5 as @e[type=player, distance=..1] as @e[type=player, sort=nearest, limit=1] run function main:reset



## Area 2 underneath logic
execute if score i_lava_timer variables matches 1 as @e[type=player] at @s if block ~ ~ ~ torch run playsound minecraft:entity.player.hurt_on_fire master @s ~ ~ ~
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=40}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 32
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=38}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 30
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=36}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 28
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=34}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 26
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=32}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 24
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=30}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 22
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=28}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 20
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=26}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 18
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=24}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 16
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=22}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 14
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=20}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 12
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=18}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 10
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=16}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 8
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=14}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 6
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=12}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 4
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=10}] at @s if block ~ ~ ~ torch run attribute @s generic.max_health base set 2
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=..8}] at @s if block ~ ~ ~ torch run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" tried to swim in lava."}]
execute if score i_lava_timer variables matches 1 as @e[type=player, scores={hearts=..8}] at @s if block ~ ~ ~ torch run function main:reset

execute if score i_lower_maze_step variables matches 0 if entity @e[type=player, scores={player_x_pos=2090..2100, player_y_pos=900..907, player_z_pos=2230..2240}] positioned 209 90 223 run function main:lower_maze_progress
execute if score i_lower_maze_step variables matches 1 if entity @e[type=player, scores={player_x_pos=2100..2110, player_y_pos=900..907, player_z_pos=2260..2270}] positioned 210 90 226 run function main:lower_maze_progress
execute if score i_lower_maze_step variables matches 2 if entity @e[type=player, scores={player_x_pos=2070..2080, player_y_pos=900..907, player_z_pos=2280..2290}] positioned 207 90 228 run function main:lower_maze_progress
execute if score i_lower_maze_step variables matches 3 if entity @e[type=player, scores={player_x_pos=2100..2110, player_y_pos=900..907, player_z_pos=2300..2310}] positioned 210 90 230 run function main:lower_maze_progress
execute if score i_lower_maze_step variables matches 4 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=900..907, player_z_pos=2270..2280}] positioned 211 90 227 run function main:lower_maze_progress
execute if score i_lower_maze_step variables matches 5 if entity @e[type=player, scores={player_x_pos=2080..2090, player_y_pos=900..907, player_z_pos=2240..2250}] positioned 208 90 224 run function main:lower_maze_progress
execute if score i_lower_maze_step variables matches 6 if entity @e[type=player, scores={player_x_pos=2090..2100, player_y_pos=900..907, player_z_pos=2280..2290}] positioned 209 90 228 run function main:lower_maze_progress
execute if score i_lower_maze_step variables matches ..6 run particle minecraft:end_rod 209.5 92.0 233.5 4 2 .2 0 4 force

execute if score chest_kill_timer variables matches 1 if entity @e[type=player, scores={chests_opened=1.., player_y_pos=..940}] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" tried to open a treasure chest."}]
execute if score chest_kill_timer variables matches 1 as @e[type=player, scores={chests_opened=1.., player_y_pos=..940}] run function main:reset

execute positioned 209 90 238 if entity @e[type=item_frame, limit=1, sort=nearest, distance=..3, nbt=!{Item:{id:"minecraft:compass"}}] if score b_compass_taken variables matches 0 run setblock 209 101 199 oak_fence_gate
execute positioned 209 90 238 if entity @e[type=item_frame, limit=1, sort=nearest, distance=..3, nbt=!{Item:{id:"minecraft:compass"}}] if score b_compass_taken variables matches 0 run fill 208 103 199 210 104 201 air
execute positioned 209 90 238 if entity @e[type=item_frame, limit=1, sort=nearest, distance=..3, nbt=!{Item:{id:"minecraft:compass"}}] if score b_compass_taken variables matches 0 run scoreboard players set b_compass_taken variables 1

particle lava 205.5 88.2 211.0 5 1 3 1 1 force

execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 200 run playsound minecraft:block.lava.ambient master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 150 run playsound minecraft:block.lava.ambient master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 100 run playsound minecraft:block.lava.ambient master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 50 run playsound minecraft:block.lava.ambient master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 30 run playsound minecraft:block.lava.pop master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 70 run playsound minecraft:block.lava.pop master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 110 run playsound minecraft:block.lava.pop master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 150 run playsound minecraft:block.lava.pop master @s 209.5 90.00 214.0
execute as @e[type=player, x=205, y=87, z=211, dx=9, dy=5, dz=9] if score i_lava_sound_timer variables matches 190 run playsound minecraft:block.lava.pop master @s 209.5 90.00 214.0

clear @a item_frame



### Area 3 logic
execute if entity @e[type=player, x=208.9, y=104.0, z=225.9, dx=2.2, dy=1.0, dz=1.2] if block 209 102 226 enchanting_table run particle minecraft:portal 209 102 226 0 0 0 .1 40 force
execute if entity @e[type=player, x=208.9, y=104.0, z=225.9, dx=2.2, dy=1.0, dz=1.2] if block 209 102 226 enchanting_table run particle minecraft:reverse_portal 210 102 226 0 0 0 .1 40 force
execute if entity @e[type=player, x=208.9, y=104.0, z=225.9, dx=2.2, dy=1.0, dz=1.2] run setblock 209 102 226 air
execute if entity @e[type=player, x=208.9, y=104.0, z=225.9, dx=2.2, dy=1.0, dz=1.2] run setblock 210 102 226 enchanting_table

execute if entity @e[type=player, x=206.9, y=105.0, z=227.9, dx=1.2, dy=1.0, dz=2.2] if block 207 103 229 enchanting_table run particle minecraft:portal 207 103 229 0 0 0 .1 40 force
execute if entity @e[type=player, x=206.9, y=105.0, z=227.9, dx=1.2, dy=1.0, dz=2.2] if block 207 103 229 enchanting_table run particle minecraft:reverse_portal 207 103 228 0 0 0 .1 40 force
execute if entity @e[type=player, x=206.9, y=105.0, z=227.9, dx=1.2, dy=1.0, dz=2.2] run setblock 207 103 229 air
execute if entity @e[type=player, x=206.9, y=105.0, z=227.9, dx=1.2, dy=1.0, dz=2.2] run setblock 207 103 228 enchanting_table

execute if entity @e[type=player, x=209.9, y=106.0, z=228.9, dx=2.2, dy=1.0, dz=2.2] if block 211 104 229 enchanting_table run particle minecraft:portal 211 104 229 0 0 0 .1 40 force
execute if entity @e[type=player, x=209.9, y=106.0, z=228.9, dx=2.2, dy=1.0, dz=2.2] if block 211 104 229 enchanting_table run particle minecraft:reverse_portal 210 104 230 0 0 0 .1 40 force
execute if entity @e[type=player, x=209.9, y=106.0, z=228.9, dx=2.2, dy=1.0, dz=2.2] run setblock 211 104 229 air
execute if entity @e[type=player, x=209.9, y=106.0, z=228.9, dx=2.2, dy=1.0, dz=2.2] run setblock 210 104 230 enchanting_table

execute if entity @e[type=player, x=206.9, y=108.0, z=223.9, dx=2.2, dy=1.0, dz=2.2] if block 207 106 225 enchanting_table run particle minecraft:portal 207 106 225 0 0 0 .1 40 force
execute if entity @e[type=player, x=206.9, y=108.0, z=223.9, dx=2.2, dy=1.0, dz=2.2] if block 207 106 225 enchanting_table run particle minecraft:reverse_portal 208 106 224 0 0 0 .1 40 force
execute if entity @e[type=player, x=206.9, y=108.0, z=223.9, dx=2.2, dy=1.0, dz=2.2] run setblock 207 106 225 air
execute if entity @e[type=player, x=206.9, y=108.0, z=223.9, dx=2.2, dy=1.0, dz=2.2] run setblock 208 106 224 enchanting_table

execute if entity @e[type=player, x=208.9, y=109.0, z=226.9, dx=1.2, dy=1.0, dz=2.2] if block 209 107 227 enchanting_table run particle minecraft:portal 209 107 227 0 0 0 .1 40 force
execute if entity @e[type=player, x=208.9, y=109.0, z=226.9, dx=1.2, dy=1.0, dz=2.2] if block 209 107 227 enchanting_table run particle minecraft:reverse_portal 209 107 228 0 0 0 .1 40 force
execute if entity @e[type=player, x=208.9, y=109.0, z=226.9, dx=1.2, dy=1.0, dz=2.2] run setblock 209 107 227 air
execute if entity @e[type=player, x=208.9, y=109.0, z=226.9, dx=1.2, dy=1.0, dz=2.2] run setblock 209 107 228 enchanting_table

execute as @e[type=player] at @s if block ~ ~ ~ #main:quicksand run tp @s ~ ~-0.1 ~
execute as @e[type=player] at @s if block ~ ~ ~ #main:quicksand run playsound minecraft:block.honey_block.fall master @s ~ ~ ~
execute as @e[type=player] at @s if block ~ ~ ~ #main:quicksand run effect give @s jump_boost 9999 128 true
execute as @e[type=player] at @s if block ~ ~2 ~ #main:quicksand run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" drowned in quick sand."}]
execute as @e[type=player] at @s if block ~ ~2 ~ #main:quicksand run function main:reset

execute if score i_lower_maze_step variables matches 7 if score i_upper_maze_step variables matches 0 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2230..2240}] positioned 211 101 223 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 1 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2240..2250}] positioned 211 101 224 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 2 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2250..2260}] positioned 211 101 225 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 3 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2260..2770}] positioned 211 101 226 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 4 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2270..2280}] positioned 211 101 227 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 5 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2280..2290}] positioned 211 101 228 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 6 if entity @e[type=player, scores={player_x_pos=2100..2110, player_y_pos=1010..1015, player_z_pos=2280..2290}] positioned 210 101 228 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 7 if entity @e[type=player, scores={player_x_pos=2090..2100, player_y_pos=1010..1015, player_z_pos=2280..2290}] positioned 209 101 228 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 8 if entity @e[type=player, scores={player_x_pos=2080..2090, player_y_pos=1010..1015, player_z_pos=2280..2290}] positioned 208 101 228 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 9 if entity @e[type=player, scores={player_x_pos=2080..2090, player_y_pos=1010..1015, player_z_pos=2270..2280}] positioned 208 101 227 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 10 if entity @e[type=player, scores={player_x_pos=2080..2090, player_y_pos=1010..1015, player_z_pos=2260..2270}] positioned 208 101 226 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 11 if entity @e[type=player, scores={player_x_pos=2070..2080, player_y_pos=1010..1015, player_z_pos=2260..2270}] positioned 207 101 226 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 12 if entity @e[type=player, scores={player_x_pos=2060..2070, player_y_pos=1010..1015, player_z_pos=2260..2270}] positioned 206 101 226 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 13 if entity @e[type=player, scores={player_x_pos=2060..2070, player_y_pos=1010..1015, player_z_pos=2270..2280}] positioned 206 101 227 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 14 if entity @e[type=player, scores={player_x_pos=2060..2070, player_y_pos=1010..1015, player_z_pos=2280..2290}] positioned 206 101 228 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 15 if entity @e[type=player, scores={player_x_pos=2060..2070, player_y_pos=1010..1015, player_z_pos=2290..2300}] positioned 206 101 229 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 16 if entity @e[type=player, scores={player_x_pos=2060..2070, player_y_pos=1010..1015, player_z_pos=2300..2310}] positioned 206 101 230 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 17 if entity @e[type=player, scores={player_x_pos=2070..2080, player_y_pos=1010..1015, player_z_pos=2300..2310}] positioned 207 101 230 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 18 if entity @e[type=player, scores={player_x_pos=2080..2090, player_y_pos=1010..1015, player_z_pos=2300..2310}] positioned 208 101 230 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 19 if entity @e[type=player, scores={player_x_pos=2090..2100, player_y_pos=1010..1015, player_z_pos=2300..2310}] positioned 209 101 230 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 20 if entity @e[type=player, scores={player_x_pos=2100..2110, player_y_pos=1010..1015, player_z_pos=2300..2310}] positioned 210 101 230 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 21 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2300..2310}] positioned 211 101 230 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 22 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2310..2320}] positioned 211 101 231 run function main:upper_maze_progress
execute if score i_upper_maze_step variables matches 23 if entity @e[type=player, scores={player_x_pos=2110..2120, player_y_pos=1010..1015, player_z_pos=2320..2330}] positioned 211 101 232 run function main:upper_maze_progress

execute if score b_open_fence_gate variables matches 0 if block 211 101 232 acacia_fence_gate[open=true] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" tried to open the left acacia fence gate."}]
execute if score b_open_fence_gate variables matches 0 if block 211 101 232 acacia_fence_gate[open=true] as @e[type=player, sort=nearest, limit=1] run function main:reset

execute if block 207 101 232 acacia_fence_gate[open=true] run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" tried to open the right acacia fence gate."}]
execute if block 207 101 232 acacia_fence_gate[open=true] as @e[type=player, sort=nearest, limit=1] run function main:reset



### Area 4 logic
execute if block 209 101 233 dark_oak_button[powered=true] run scoreboard players set b_open_fence_gate variables 1
execute if block 209 101 233 dark_oak_button[powered=true] run setblock 211 101 232 air
execute if block 209 101 233 dark_oak_button[powered=true] run setblock 211 101 232 acacia_fence_gate[open=true, facing=south]
execute if block 209 101 233 dark_oak_button[powered=true] run setblock 209 101 233 air

execute if block 210 104 235 redstone_lamp[lit=true] if block 208 104 235 redstone_lamp[lit=true] run setblock 209 99 236 redstone_wall_torch[facing=north]
execute if block 210 104 235 redstone_lamp[lit=false] run setblock 209 99 236 air
execute if block 208 104 235 redstone_lamp[lit=false] run setblock 209 99 236 air

execute unless block 209 101 190 barrel{Items:[{Slot: 13b, id: "minecraft:written_book", Count: 1b, tag: {pages: ['{"text":"Give me the colors\\n\\n\\nfrom left to right\\n\\n\\nas they are from\\n\\n\\nbottom to top\\n"}'], title: "Mysterious Book", author: "Secret"}}]} run tellraw @a [{"selector":"@e[type=player, sort=nearest, limit=1]", "color":"yellow"}, {"color":"red", "text":" tried to steal the mysterious book."}]
execute unless block 209 101 190 barrel{Items:[{Slot: 13b, id: "minecraft:written_book", Count: 1b, tag: {pages: ['{"text":"Give me the colors\\n\\n\\nfrom left to right\\n\\n\\nas they are from\\n\\n\\nbottom to top\\n"}'], title: "Mysterious Book", author: "Secret"}}]} as @e[type=player, sort=nearest, limit=1] run function main:reset

execute if score i_head_space variables matches 0 if block 209 101 190 barrel[open=true] run scoreboard players set i_head_space variables 1
execute if score i_head_space variables matches 1 as @e[type=player] run item replace entity @s armor.head with written_book{pages: ['{"text":"Give me the colors\\n\\n\\nfrom left to right\\n\\n\\nas they are from\\n\\n\\nbottom to top\\n"}'], title: "Mysterious Book", author: "Secret"} 1
#execute if score i_head_space variables matches 1 run replaceitem entity @e[type=player, sort=nearest, limit=1] armor.head air
#execute if score i_head_space variables matches 20 run replaceitem entity @e[type=player, sort=nearest, limit=1] armor.head written_book{pages: ['{"text":"Give me the colors\\n\\n\\nfrom left to right\\n\\n\\nas they are from\\n\\n\\nbottom to top\\n"}'], title: "Mysterious Book", author: "Secret"}
execute if score i_head_space variables matches 1..19 run scoreboard players add i_head_space variables 1
execute if score i_head_space variables matches 20 as @e[type=player] if data entity @s {Inventory:[{Slot:103b, id:"minecraft:written_book"}]} run scoreboard players add i_head_space variables 1

execute if blocks 209 101 190 209 101 190 209 101 188 all if score b_bamboo_given variables matches 0 run give @e[type=player, sort=nearest, limit=1] bamboo{display:{Lore:["\"Part of a magic wand.\""]}}
execute if blocks 209 101 190 209 101 190 209 101 188 all run scoreboard players set b_bamboo_given variables 1

execute if entity @e[type=player, scores={player_z_pos=2329..2380, player_y_pos=1050..1350, player_x_pos=2059..2130}] if block 207 113 192 air run playsound block.note_block.bell master @a 209.5 107.00 232.5
execute if entity @e[type=player, scores={player_z_pos=2329..2380, player_y_pos=1050..1350, player_x_pos=2059..2130}] run setblock 207 113 192 target
execute unless entity @e[type=player, scores={player_z_pos=2329..2380, player_y_pos=1050..1350, player_x_pos=2059..2130}] if block 207 113 192 target run playsound block.note_block.didgeridoo master @a 209.5 107.00 232.5
execute unless entity @e[type=player, scores={player_z_pos=2329..2380, player_y_pos=1050..1350, player_x_pos=2059..2130}] run setblock 207 113 192 air


### Area 4 high logic
execute if entity @e[type=snowball, scores={player_z_pos=2427..2443, player_y_pos=1180..1210, player_x_pos=2137..2153}] run setblock 214 118 243 sticky_piston[facing=up]

execute if score apple_lock_timer variables matches 0 positioned 203.5 117.5 247.00 as @e[type=item_frame, sort=nearest, limit=1] if entity @s[nbt={Item:{id:"minecraft:apple", Count: 1b}}] run scoreboard players set apple_lock_timer variables 60
execute if score apple_lock_timer variables matches 1.. run scoreboard players remove apple_lock_timer variables 1
execute if score apple_lock_timer variables matches 50 run playsound minecraft:block.enchantment_table.use master @a 203.5 117.5 247.00 99999 1.3
execute if score apple_lock_timer variables matches 30 run playsound minecraft:block.enchantment_table.use master @a 203.5 117.5 247.00 99999 1
execute if score apple_lock_timer variables matches 10 run playsound minecraft:block.enchantment_table.use master @a 203.5 117.5 247.00 99999 0.7
execute if score apple_lock_timer variables matches 1 run execute positioned 203.5 117.5 247.00 run kill @e[type=item_frame, sort=nearest, limit=1]
execute if score apple_lock_timer variables matches 1 run setblock 203 116 246 air
execute if score apple_lock_timer variables matches 1 run setblock 203 117 246 air



### Area 'sacred knowledge cubes' logic
execute as @e[type=player, x=208, y=100, z=191, dx=2, dy=3, dz=3] run tellraw @a [{"selector":"@s", "color":"yellow"}, {"color":"red", "text":" set foot inside a sacred knowledge cube."}]
execute as @e[type=player, x=208, y=100, z=191, dx=2, dy=3, dz=3] run function main:reset

execute as @e[type=player, x=202, y=116, z=243, dx=2, dy=3, dz=3] run tellraw @a [{"selector":"@s", "color":"yellow"}, {"color":"red", "text":" set foot inside a sacred knowledge cube."}]
execute as @e[type=player, x=202, y=116, z=243, dx=2, dy=3, dz=3] run function main:reset

execute if entity @e[type=player, nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] unless entity @e[type=player, nbt={Inventory:[{id:"minecraft:carrot_on_a_stick", tag:{display:{}}}]}] run scoreboard players set i_craft_magic_wand variables 1
execute if score i_craft_magic_wand variables matches 1 run clear @a carrot_on_a_stick
execute if score i_craft_magic_wand variables matches 1 run give @e[type=player, limit=1] carrot_on_a_stick{display:{Name:'{"text":"Magic wand"}', Lore:["\"You can aim with this.\""]}}
execute if score i_craft_magic_wand variables matches 1 run scoreboard players set i_craft_magic_wand variables 2

clear @a mangrove_roots
item replace block 209 101 190 container.0 with mangrove_roots
item replace block 209 101 190 container.1 with mangrove_roots
item replace block 209 101 190 container.2 with mangrove_roots
item replace block 209 101 190 container.3 with mangrove_roots
item replace block 209 101 190 container.4 with mangrove_roots
item replace block 209 101 190 container.5 with mangrove_roots
item replace block 209 101 190 container.6 with mangrove_roots
item replace block 209 101 190 container.7 with mangrove_roots
item replace block 209 101 190 container.8 with mangrove_roots
item replace block 209 101 190 container.9 with mangrove_roots
item replace block 209 101 190 container.17 with mangrove_roots
item replace block 209 101 190 container.18 with mangrove_roots
item replace block 209 101 190 container.19 with mangrove_roots
item replace block 209 101 190 container.20 with mangrove_roots
item replace block 209 101 190 container.21 with mangrove_roots
item replace block 209 101 190 container.22 with mangrove_roots
item replace block 209 101 190 container.23 with mangrove_roots
item replace block 209 101 190 container.24 with mangrove_roots
item replace block 209 101 190 container.25 with mangrove_roots
item replace block 209 101 190 container.26 with mangrove_roots



execute if score i_item_kill variables matches 0 if blocks 209 100 237 209 100 237 209 98 237 all if entity @e[type=player, scores={player_z_pos=..2320}] run scoreboard players set i_item_kill variables 1
execute if score i_item_kill variables matches 1 run kill @e[type=item]
execute if score i_item_kill variables matches 1 run tellraw @a [{"color":"gold", "text":"The terracotta has been taken. All item entities are now deleted. Too bad if you needed the items on the pressure plates back."}]
execute if score i_item_kill variables matches 1 run scoreboard players set i_item_kill variables 2



execute at @e[scores={magic_wand_use=1..}] run summon armor_stand ^ ^1.5 ^.5 {Invisible:1b, NoGravity:1b, Tags:[projectile, red]}
execute at @e[scores={magic_wand_use=1..}] run summon armor_stand ^ ^1.5 ^.5 {Invisible:1b, NoGravity:1b, Tags:[rotator, red], Rotation:[0f, 0f]}
execute as @e[scores={magic_wand_use=1..}] at @s run data modify entity @e[tag=projectile, sort=nearest, limit=1] Rotation set from entity @s Rotation
execute as @e[scores={magic_wand_use=1..}] at @s run data modify entity @e[tag=rotator, sort=nearest, limit=1] Rotation set from entity @s Rotation
execute as @e[scores={magic_wand_use=1..}] at @s run scoreboard players set @e[tag=projectile, sort=nearest, limit=1] projectile_life 0
scoreboard players reset @e[type=player] magic_wand_use

execute as @e[tag=projectile] at @s run tp @s ^ ^ ^1.2
execute as @e[tag=rotator] at @s run tp @s @e[tag=projectile, sort=nearest, limit=1]
execute as @e[tag=projectile, scores={projectile_life=800..}] at @s run kill @e[type=armor_stand, distance=..1]

scoreboard players add @e[tag=projectile] projectile_life 4
execute as @e[tag=projectile] at @s store result entity @e[tag=rotator, sort=nearest, limit=1] Rotation[0] float 1 run scoreboard players get @s projectile_life

execute as @e[tag=projectile, x=203, y=115, z=245, dx=1, dy=2, dz=1] run tag @s remove red
execute as @e[tag=projectile, x=203, y=115, z=245, dx=1, dy=2, dz=1] run tag @s add green
execute as @e[tag=rotator, x=203, y=115, z=245, dx=1, dy=2, dz=1] run tag @s remove red
execute as @e[tag=rotator, x=203, y=115, z=245, dx=1, dy=2, dz=1] run tag @s add green

execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=red] run particle minecraft:dust 1 0 0 1 ^ ^0.5 ^ 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=red] run particle minecraft:dust 1 0 0 1 ^ ^-0.5 ^ 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=red] run particle minecraft:dust 1 0 0 1 ^ ^ ^0.5 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=red] run particle minecraft:dust 1 0 0 1 ^ ^ ^-0.5 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=red] run particle minecraft:dust 1 0 .6 1 ^0.5 ^ ^ 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=red] run particle minecraft:dust 1 .6 0 1 ^-0.5 ^ ^ 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=green] run particle minecraft:dust 0 1 0 1 ^ ^0.5 ^ 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=green] run particle minecraft:dust 0 1 0 1 ^ ^-0.5 ^ 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=green] run particle minecraft:dust 0 1 0 1 ^ ^ ^0.5 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=green] run particle minecraft:dust 0 1 0 1 ^ ^ ^-0.5 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=green] run particle minecraft:dust 0 1 .6 1 ^0.5 ^ ^ 0 0 0 0 1 force
execute as @e[tag=rotator] at @s rotated as @s if entity @s[tag=green] run particle minecraft:dust .6 1 0 1 ^-0.5 ^ ^ 0 0 0 0 1 force



execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=167..184}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 167 215 134 184 237 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=189..202}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 189 215 134 202 237 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=205..214}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 205 215 134 214 237 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=215..229}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 215 215 134 229 237 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=234..236}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 234 215 134 236 237 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=241..249}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 241 215 134 249 237 134 crimson_planks replace oak_planks

execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=130..148}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 130 181 134 148 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=151..164}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 151 181 134 164 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=168..183}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 168 181 134 183 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=185..207}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 185 181 134 207 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=210..212}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 210 181 134 212 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=216..231}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 216 181 134 231 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=234..247}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 234 181 134 247 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=251..265}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 251 181 134 265 209 134 crimson_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=270..284}] at @s if entity @s[tag=red] if block ~ ~ ~-5 oak_planks run fill 270 181 134 284 209 134 crimson_planks replace oak_planks

execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=167..184}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 167 215 134 184 237 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=189..202}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 189 215 134 202 237 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=205..214}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 205 215 134 214 237 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=215..229}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 215 215 134 229 237 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=234..236}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 234 215 134 236 237 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=241..249}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 241 215 134 249 237 134 warped_planks replace oak_planks

execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=130..148}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 130 181 134 148 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=151..164}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 151 181 134 164 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=168..183}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 168 181 134 183 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=185..207}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 185 181 134 207 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=210..212}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 210 181 134 212 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=216..231}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 216 181 134 231 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=234..247}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 234 181 134 247 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=251..265}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 251 181 134 265 209 134 warped_planks replace oak_planks
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=270..284}] at @s if entity @s[tag=green] if block ~ ~ ~-5 oak_planks run fill 270 181 134 284 209 134 warped_planks replace oak_planks



execute as @e[tag=projectile] at @s if block ~ ~ 134 crimson_planks run scoreboard players add i_letters_burnt variables 1
execute as @e[tag=projectile] at @s if block ~ ~ 134 crimson_planks run kill @e[type=armor_stand, distance=..1]

execute if score i_letters_burnt variables matches 3.. run tellraw @a [{"color":"red", "text":"Too many floating letters are burnt. Please don't burn the map down!"}]
execute if score i_letters_burnt variables matches 3.. as @p run function main:reset



execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=167..184}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=189..202}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 10
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=205..214}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=215..229}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=234..236}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 1
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=215..237, player_x_pos=241..249}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100

execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=130..148}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=151..164}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 10
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=168..183}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=185..207}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 1
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=210..212}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=216..231}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=234..247}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=251..265}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100
execute as @e[tag=projectile, scores={player_z_pos=134..138, player_y_pos=181..209, player_x_pos=270..284}] at @s if block ~ ~ 134 warped_planks run scoreboard players add green_letters variables 100

execute as @e[tag=projectile, scores={player_z_pos=134..138}] at @s if block ~ ~ 134 warped_planks run kill @e[type=armor_stand, distance=..1]

execute if score green_letters variables matches 12 run title @a title {"text":"WIN", "color":"green"}
execute if score green_letters variables matches 12 run title @a subtitle {"text":"You made sure to WIN"}
execute if score green_letters variables matches 12 run tp @a 209.5 115.00 246.5 180 -30
execute if score green_letters variables matches 12 run gamemode creative @a
execute if score green_letters variables matches 12 run fill 208 117 245 210 117 247 air
execute if score green_letters variables matches 12 run scoreboard players add green_letters variables 10000

